/*
 * Created on Aug 30, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package schelling;

import java.io.*;

public class ReadFile {

	private static final char EMPTY = '0';
	private static final char GREEN = '1';
	private static final char RED = '2';
	
	private String[] cellGrid;
	private int numLines;
	
	private boolean[] Error = {false,false,false};
	
	public ReadFile() {
		try {
			FileReader reader = new FileReader("cells.txt");
			BufferedReader buff = new BufferedReader(reader);
			
			String line = buff.readLine();
			
			numLines = new Integer(line).intValue();
			cellGrid = new String[numLines];
			
			int index = 0;
			while((line = buff.readLine()) != null) {
				if(line.length() != numLines) {
					Error[1] = true;
					break;
				}
				else if (invalidChars(line)) {
					Error[2] = true;
					break;
				}
				else {
					cellGrid[index++] = line;
				}
			}
		} catch (IOException e) {
			Error[0] = true;
		}
	}
	
	public String[] getGrid() {
		return cellGrid;
	}
	
	public String getError() {
		if(Error[0]) {
			return "File was not found, looking for cells.txt";
		}
		else if(Error[1]) {
			return "Grid format is not a perfect square";
		}
		else if(Error[2]) {
			return "Grid has an invalid character, valid characters are 0,1,2";
		}
		else 
			return null;
	}
	
	private boolean invalidChars(String check) {
		for(int x = 0; x < check.length(); x++) {
			if(check.charAt(x) != EMPTY && check.charAt(x) != GREEN && check.charAt(x) != RED) {
				return true;
			}
		}
		return false;
	}
}
